﻿namespace ProjectMotorboat.Drownings;

public class DrawningBoatCompareByType : IComparer<DrawningBoat?>
{
    public int Compare(DrawningBoat? x, DrawningBoat? y)
    {
        if (x == null || x.EntityBoat == null)
        {
            return -1;
        }

        if (y == null || y.EntityBoat == null)
        {
            return 1;
        }

        if (x.GetType().Name != y.GetType().Name)
        {
            return x.GetType().Name.CompareTo(y.GetType().Name);
        }

        var speedCompare = x.EntityBoat.Speed.CompareTo(y.EntityBoat.Speed);
        if (speedCompare != 0)
        {
            return speedCompare;
        }

        return x.EntityBoat.Weight.CompareTo(y.EntityBoat.Weight);
    }
}
